package dev.shadowsoffire.apotheosis.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.Style;
import net.minecraft.util.RandomSource;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.levelgen.LegacyRandomSource;
import net.minecraftforge.common.crafting.AbstractIngredient;
import net.minecraftforge.common.crafting.IIngredientSerializer;

public class AffixItemIngredient extends AbstractIngredient {
  protected final DynamicHolder<LootRarity> rarity;
  
  protected ItemStack[] items;
  
  public AffixItemIngredient(DynamicHolder<LootRarity> rarity) {
    this.rarity = rarity;
  }
  
  public boolean test(ItemStack stack) {
    DynamicHolder<LootRarity> rarity = AffixHelper.getRarity(stack);
    Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(stack);
    return (affixes.size() > 0 && rarity.isBound() && rarity == this.rarity);
  }
  
  public ItemStack[] m_43908_() {
    if (this.items == null)
      this.items = createFakeDisplayItems((LootRarity)this.rarity.get()).<ItemStack>toArray(new ItemStack[0]); 
    return this.items;
  }
  
  protected void invalidate() {
    super.invalidate();
    this.items = null;
  }
  
  public boolean isSimple() {
    return false;
  }
  
  public IIngredientSerializer<? extends Ingredient> getSerializer() {
    return (IIngredientSerializer<? extends Ingredient>)Serializer.INSTANCE;
  }
  
  public JsonElement m_43942_() {
    return (JsonElement)new JsonObject();
  }
  
  public LootRarity getRarity() {
    return (LootRarity)this.rarity.get();
  }
  
  private static List<ItemStack> createFakeDisplayItems(LootRarity rarity) {
    LegacyRandomSource legacyRandomSource = new LegacyRandomSource(0L);
    List<ItemStack> out = Arrays.<Item>asList(new Item[] { Items.f_42388_, Items.f_42390_, Items.f_42472_, Items.f_42473_, Items.f_42474_, Items.f_42475_ }).stream().map(ItemStack::new).toList();
    out.forEach(stack -> {
          LootController.createLootItem(stack, rarity, src);
          AffixHelper.setName(stack, (Component)Component.m_237110_("text.apotheosis.any_x_item", new Object[] { rarity.toComponent(), "" }).m_130948_(Style.f_131099_.m_131148_(rarity.getColor())));
        });
    return out;
  }
}
